// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'agftp.pas' rev: 3.00

#ifndef agftpHPP
#define agftpHPP
#include <agConst.hpp>
#include <agFtpCls.hpp>
#include <agtypes.hpp>
#include <agsocket.hpp>
#include <Dialogs.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <agwsock.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Agftp
{
//-- type declarations -------------------------------------------------------
enum TTransferType { ftBinary, ftASCII };

class DELPHICLASS TagFTP;
class PASCALIMPLEMENTATION TagFTP : public Agsocket::TagSocket 
{
	typedef Agsocket::TagSocket inherited;
	
private:
	int FDataSocket;
	int FListenerSocket;
	System::AnsiString FUserName;
	System::AnsiString FPassword;
	TTransferType FTransferType;
	Classes::TNotifyEvent FOnTransferStart;
	Agtypes::TmsProgressEvent FOnTransferProgress;
	Classes::TNotifyEvent FOnTransferEnd;
	Classes::TStream* FTransferStream;
	Agftpcls::TagFTPDirList* FDirectory;
	Cardinal FTransferBufferSize;
	bool FRetrievingList;
	bool FTransferringFile;
	bool FUseProxy;
	System::AnsiString FProxy;
	TFTPProxyType FProxyType;
	Agftpcls::TServerType __fastcall GetServerType(void);
	void __fastcall SetServerType(Agftpcls::TServerType Value);
	System::AnsiString __fastcall GetCurrentDirectory();
	void __fastcall SetCurrentDirectory(System::AnsiString Value);
	void __fastcall SetProxy(System::AnsiString Value);
	void __fastcall DoTransferStart(System::TObject* Sender);
	void __fastcall DoTransferProgress(System::TObject* Sender, int Perc, int Transferred);
	void __fastcall DoTransferEnd(System::TObject* Sender);
	
protected:
	int DataWndHandle;
	bool DataConnectionClosed;
	bool DataTransferCanceled;
	System::AnsiString RealServer;
	HIDESBASE void __fastcall WndProc(Messages::TMessage &Msg);
	virtual void __fastcall ReInit(void);
	void __fastcall OpenListenerSocket(void);
	void __fastcall CloseListenerSocket(void);
	void __fastcall RequestDataConnection(void);
	void __fastcall AcceptDataConnection(void);
	void __fastcall CloseDataConnection(void);
	void __fastcall RecvFTPStream(int FullSize);
	void __fastcall SendFTPStream(int FullSize);
	void __fastcall FillDirList(void);
	
public:
	__fastcall virtual TagFTP(Classes::TComponent* AOwner);
	__fastcall virtual ~TagFTP(void);
	virtual void __fastcall Open(void);
	void __fastcall OpenConnection(void);
	void __fastcall CloseConnection(void);
	void __fastcall LogIn(void);
	void __fastcall LogOut(void);
	void __fastcall RetrieveFile(const System::AnsiString RemoteFilePath, const System::AnsiString LocalFilePath
		);
	void __fastcall ResumeRetrieveFile(const System::AnsiString RemoteFilePath, const System::AnsiString 
		LocalFilePath, int Marker);
	void __fastcall StoreFile(const System::AnsiString LocalFilePath, const System::AnsiString RemoteFilePath
		);
	void __fastcall ResumeStoreFile(const System::AnsiString LocalFilePath, const System::AnsiString RemoteFilePath
		, int Marker);
	void __fastcall AppendStoreFile(const System::AnsiString LocalFilePath, const System::AnsiString RemoteFilePath
		);
	void __fastcall StoreUnique(const System::AnsiString LocalFilePath, System::AnsiString &RemoteFilePath
		);
	void __fastcall GetDirectory(void);
	void __fastcall Delete_File(const System::AnsiString FileName);
	void __fastcall RenameFile(const System::AnsiString OldFileName, const System::AnsiString NewFileName
		);
	void __fastcall ChangeDirectory(const System::AnsiString Path);
	void __fastcall ChangeToUpperDirectory(void);
	void __fastcall MakeDirectory(const System::AnsiString Path);
	void __fastcall DeleteDirectory(const System::AnsiString Path);
	void __fastcall AbortTransfer(void);
	__property Agftpcls::TagFTPDirList* Directory = {read=FDirectory, write=FDirectory};
	__property bool RetrievingList = {read=FRetrievingList, nodefault};
	__property bool TransferringFile = {read=FTransferringFile, nodefault};
	__property System::AnsiString CurrentDirectory = {read=GetCurrentDirectory, write=SetCurrentDirectory
		};
	
__published:
	__property Server ;
	__property DefaultPort ;
	__property TimeOut ;
	__property OnOpen ;
	__property OnConnected ;
	__property OnClosing ;
	__property OnClosed ;
	__property OnCancel ;
	__property OnError ;
	__property OnLineSent ;
	__property OnLineReceived ;
	__property System::AnsiString UserName = {read=FUserName, write=FUserName};
	__property System::AnsiString Password = {read=FPassword, write=FPassword};
	__property Agftpcls::TServerType ServerType = {read=GetServerType, write=SetServerType, nodefault};
		
	__property bool UseProxy = {read=FUseProxy, write=FUseProxy, default=0};
	__property System::AnsiString Proxy = {read=FProxy, write=SetProxy};
	__property Agftpcls::TFTPProxyType ProxyType = {read=FProxyType, write=FProxyType, nodefault};
	__property Cardinal TrasferBufferSize = {read=FTransferBufferSize, write=FTransferBufferSize, default=2048
		};
	__property TTransferType TransferType = {read=FTransferType, write=FTransferType, default=0};
	__property Classes::TNotifyEvent OnTransferStart = {read=FOnTransferStart, write=FOnTransferStart};
		
	__property Agtypes::TmsProgressEvent OnTransferProgress = {read=FOnTransferProgress, write=FOnTransferProgress
		};
	__property Classes::TNotifyEvent OnTransferEnd = {read=FOnTransferEnd, write=FOnTransferEnd};
};

//-- var, const, procedure ---------------------------------------------------

}	/* namespace Agftp */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Agftp;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// agftp
